<?php

$misto = $_SERVER['HTTP_HOST'];
$rss = "http://$misto/rss.xml";
/*
	Vytvoril Honza Javorek http://honzajavorek.cz/, puvodne pro Michala Janika http://www.michaljanik.cz/.
	muzes predat i parametrem treba jako ?src=http://www.michaljanik.cz/rss.xml
	a tady napises $rss = $_GET['src'], ale pozor na zneuziti
*/
$param = 'utm_source=rss&amp;utm_medium=feed&amp;utm_campaign=rss';
/*
	bez otazniku/ampersandu na zacatku a ampersandy je treba psat jako &amp;,
	protoze to jde primo do XML toho RSS
*/


/******************************************************************************/

function extras($rss) {

	/*
	 
		- sem muzes napsat jakekoliv PHP, ktere se vzdy spusti
		- v parametru dostavas zdrojovy kod toho RSS s uz upravenymi linky,
		    kdybys s nim chtel neco dal delat
		- kdybys s nim pracoval a chtel ho jeste nejak dal menit, muzes narazit
			na mozne problemy: RSS muze byt v jakemkoliv kodovani; ampersandy
			by se do nej mely vkladat jako &amp; a ne jen jako &, jinak to
			zpusobi XML parse error
		- pokud budes chtit treba jen spustit tu google analytics tecku, jak jsi
		    naznacoval, parametr $rss nepotrebujes a delas si v teto funkci jen
		    to svoje... nevsimas si ho a jen ho nedotknuty vratis v return
	 
	 */


	return $rss;
}

/******************************************************************************/


function error($msg) {
    header('Content-Type: text/html; charset=utf-8');
    header('HTTP/1.1 500 Internal Server Error');
	die($msg);
}

function ini_get_bool($a) {
    $b = ini_get($a);
    switch (strtolower($b)) {
	    case 'on':
	    case 'yes':
	    case 'true':
	        return 'assert.active' !== $a;
	    case 'stdout':
	    case 'stderr':
	        return 'display_errors' === $a;
	    default:
	        return (bool) (int) $b;
	}
}

function download($url) {
	if (ini_get_bool('allow_url_fopen')) {
		return file_get_contents($url);
	} elseif(extension_loaded('curl')) {
		$ch = curl_init();
		$timeout = 5;
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		$data = curl_exec($ch);
		curl_close($ch);
		return $data;
	} else {
		return FALSE;
	}
}

function replace($matches) {
	global $param;
	if (strrpos($matches[1], '?') === false) {
		$link = "$matches[1]?$param";
	} else { // ma uz nejake parametry
        $link = "$matches[1]&amp;$param";
	}
	return str_replace($matches[1], $link, $matches[0]);
}

$result = download($rss);
if ($result) {
	$result = preg_replace_callback('~<link>(http://[^<\\s]+)</link>~i', 'replace', $result);
	$result = extras($result);
	header('Content-Type: application/rss+xml');
	echo $result;
} else {
	error('Nepodařilo se stáhnout RSS.');
}
